#
# Copyright (C) 2021 Associated Universities, Inc. Washington DC, USA.
#
# This file is part of NRAO Workspaces.
#
# Workspaces is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Workspaces is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Workspaces.  If not, see <https://www.gnu.org/licenses/>.
"""
Testing suite for ws_metrics
"""
import argparse
import logging
import sys


logger = logging.getLogger("test_ws_metrics")
logger.setLevel(logging.INFO)
logger.addHandler(logging.StreamHandler(sys.stdout))

args_b = argparse.Namespace(between=["null", "2021-03-30T00:00:00", "2021-03-30T23:59:59"], capability=None)
result_b = 4

args_c = argparse.Namespace(between=None, capability="null")
result_c = 10

args_rd = argparse.Namespace(requestdatasize=["1"], datasize=None)
result_rd = 10

args_d = argparse.Namespace(requestdatasize=None, datasize=["2021-03-30T00:00:00", "2021-03-30T23:59:59"])
result_d = 100

# they're all broken anyway

# def mock_leu(args: argparse.Namespace) -> LifeUniverseEverything:
#     with patch("psycopg2.connect") as mock_connect:
#         return LifeUniverseEverything(connection=mock_connect, args=args)


# mock_leu_b = mock_leu(args_b)
# mock_leu_c = mock_leu(args_c)
# mock_leu_rd = mock_leu(args_rd)
# mock_leu_d = mock_leu(args_d)


# class TestWSMetrics:
#     @pytest.mark.skip("broken by rewrite")
#     def test_get_total_cap_executions(self):
#         mock_leu_c.conn.cursor.return_value.fetchone.return_value = result_c
#         assert args_c.capability == "null"
#         value = mock_leu_c.get_total_cap_executions(args_c.capability)
#         assert value == result_c
#
#     @pytest.mark.skip("broken by rewrite")
#     def test_get_total_executions_in_range(self):
#         mock_leu_b.conn.cursor.return_value.fetchone.return_value = result_b
#         assert args_b.between[0] == "null"
#         assert args_b.between[1] == "2021-03-30T00:00:00"
#         assert args_b.between[2] == "2021-03-30T23:59:59"
#         value = mock_leu_b.get_total_executions_in_range(args_b.between[0], args_b.between[1], args_b.between[2])
#         assert value == result_b
#
#     @pytest.mark.skip("broken by rewrite")
#     def test_get_total_data_volume(self):
#         mock_leu_d.conn.cursor.return_value.fetchone.return_value = result_d
#         assert args_d.datasize[0] == "2021-03-30T00:00:00"
#         assert args_d.datasize[1] == "2021-03-30T23:59:59"
#         value = mock_leu_d.get_total_data_volume(args_d.datasize[0], args_d.datasize[1])
#         assert value == result_d
#
#     @pytest.mark.skip("broken by rewrite")
#     def test_get_request_data_volume(self):
#         mock_leu_rd.conn.cursor.return_value.fetchone.return_value = result_rd
#         assert args_rd.requestdatasize[0] == "1"
#         value = mock_leu_rd.get_request_data_volume("1")
#         assert value == result_rd
