"""add flagtemplate file to calibration capability

Revision ID: 0d9ba97bf3a5
Revises: edf1dd4da767
Create Date: 2022-11-02 15:10:52.101777

"""
from pathlib import Path

from alembic import op

# revision identifiers, used by Alembic.
from sqlalchemy.orm import Session

# This import can cause issues when trying to do a bare-bones
# alembic command for a fresh revision.   Let the import fail
# quietly, the import will work in the schema container
try:
    from workspaces.capability.schema import CapabilityTemplate
except ImportError:
    pass

# revision identifiers, used by Alembic.
revision = "0d9ba97bf3a5"
down_revision = "edf1dd4da767"
branch_labels = None
depends_on = None


def upgrade():
    session = Session(bind=op.get_bind())

    # add the templates
    flag = CapabilityTemplate(
        filename="flagtemplate.txt",
        content=(Path.cwd() / "versions" / "templates" / "flagtemplate-2022-11-02.txt").read_text().encode("ascii"),
        capability_name="std_calibration",
    )
    session.add(flag)
    session.commit()


def downgrade():
    session = Session(bind=op.get_bind())
    cal = (
        session.query(CapabilityTemplate)
        .filter_by(filename="flagtemplate.txt", calibration_name="std_calibration")
        .one()
    )
    session.delete(cal)
